# Updating the tW list for PDFs  
  
These procedures work on my Mac. If a version is needed for another machine, I can adapt it, as can anyone familiar with scripts.  
  
## Files needed

I have put the files I use in the Git. The directory structures assumed by the scripts will have to be changed if the work is done on another machine. (At some point I'll need to make this a single-directory package.)
  
### Shell scripts (Batch files in Windows)  
  
do.sh  
mine.sh  
update.sh  
waa.sh
  
### Perl scripts  
  
CombineULBandNASBwithCodes.pl  
ExtractLinksFromScratchPad.pl  
FindMismatchedULBSnippets.2.noChunks.pl  
GrepBook.pl  
MakeULB.2.pl  
Mine.URL.Strong.Verse.pl  
OpenMismatchedFiles.pl  
Output.to.csv.pl

### Exceptions file

Exceptions.tWs.from.UGNT.txt

## Procedures

**First run do.sh**

    	>sh do.sh
        
This will pull the latest of all files down, update the ULB, and check for missing key words.

**For each missing keyword pair in the missing.log file**

* Select the line, including the EOL
* Run mine.sh

     	>sh mine.sh
     	
* Paste the copied line to answer the prompt
* Choose the best alternative
	* change key word associated with the Strong's number
	* specify ULB text to go with that key word
	* comment out the key word so it is not in the tW list
	
**After dealing with all missing words**

* Push all changes to the Git
* Run do.sh again to make sure no new errors have been introduced
* Run waa.sh to check for and correct ULB–tN snippet mismatches

**After all corrections have been made**

* Run Output.to.csv.pl to update the local repo
* Commit all changes